	.include	doscall.equ
	.text
start:
	addq.l	#1,a2
	lea	usersp,sp
	lea	I_fname,a1
	bsr	getarg
	tst.l	d0
	beq	CL1ERR
	lea	O_fname,a1
	bsr	getarg
	tst.l	d0
	beq	CL2ERR

	clr.w	-(sp)
	pea.l	I_fname
	DOS	OPEN
	addq.l	#6,sp
	blt	R_ERR
	move.w	d0,fp1
	move.w	#$20,-(sp)
	pea.l	O_fname
	DOS	CREATE
	addq.l	#6,sp
	blt	CR_ERR
	move.w	d0,fp2
~l1:
	bsr	getc
	tst.w	d0
	blt	~l3
	cmpi.w #$0d,d0
	bne	~i1
~l4:
	bsr	getc
	move	d0,d2
	cmpi.w #$0a,d0
	bne	~i2
	bsr	putc
	bra	~i3
~i2:
	cmpi.w #$0d,d0
	beq	~i4
	move.w	d0,d1
	move.w	#$0d,d0
	bsr	putc
	move.w	d1,d0
	bsr	putc
	bra	~i3
~i4:
	bsr	putc
~i0:
~i5:
~i3:
~l5:
	cmpi.w #$0d,d2
	beq	~l4
~l6:
	bra	~i6
~i1:
	bsr	putc
~i6:
~l2:
	bra	~l1
~l3:

	move.w	fp1,-(sp)
	DOS	CLOSE
	addq.l	#2,sp
	bsr	close_fp2
	pea	finish_m
	DOS	PRINT
	addq.l	#4,sp
	DOS	EXIT

read_buf_len	EQU	10240

rbuff_len:	.dc.w	0
rpointer:	.dc.w	$ffff

getc:
	movem.l d1-d2,-(sp)
getcL1:
	move.w	rpointer,d1
	move.w	rbuff_len,d2
	addq.l	#1,d1
	cmp.w	d1,d2
	bne	getc_C1

	move.l	#read_buf_len,-(sp)
	pea	rbuff
	move.w	fp1,-(sp)
	DOS	READ
	lea	10(sp),sp
	tst.l	d0
	blt	R_ERR
	beq	getc_EOF
	move.w	d0,rbuff_len
	moveq.l #-1,d1
	move.w	d1,rpointer
	bra	getcL1

getc_EOF:
	moveq.l #-1,d0
	movem.l (sp)+,d1-d2
	rts

getc_C1:
	lea	rbuff,a1
	moveq.l #0,d0
	move.b	(a1,d1.w),d0
	move.w	d1,rpointer
	movem.l (sp)+,d1-d2
	rts

write_buf_len	EQU	10240

wpointer:	.dc.w	0


putc:
	move.l	d1,-(sp)

	move.w	wpointer,d1
	lea	wbuff,a1
	move.b	d0,(a1,d1.w)
	addq.l	#1,d1
	move.w	d1,wpointer
	cmpi.w	#write_buf_len,d1
	bne	putc_end
	move.l	#write_buf_len,-(sp)
	pea	wbuff
	move.w	fp2,-(sp)
	DOS	WRITE
	lea	10(sp),sp
	cmpi.w	#write_buf_len,d0
	bne	W_ERR
	move.w	#0,wpointer

putc_end:

	move.l	(sp)+,d1
	rts

close_fp2:
	move.w	wpointer,d0
	ext.l	d0
	move.l	d0,-(sp)
	pea	wbuff
	move.w	fp2,-(sp)
	DOS	WRITE
	lea	10(sp),sp
	cmp.w	wpointer,d0
	bne	W_ERR

	move.w	fp2,-(sp)
	DOS	CLOSE
	addq.l	#2,sp
	rts

CL1ERR:
CL2ERR:
R_ERR:
CR_ERR:
W_ERR:
	pea	ERR_MES
	DOS	PRINT
	addq.l	#4,sp
	DOS	EXIT

getarg:
	moveq.l #0,d0
	move.l	d1,-(sp)

getarg_L0:
	move.b	(a2)+,d1
	beq	getarg_end
	cmpi.b	#' ',d1
	beq	getarg_L0
	cmpi.b	#9,d1
	beq	getarg_L0

getarg_L2:
	move.b	d1,(a1)+
	addq.l	#1,d0
	move.b	(a2)+,d1
	beq	getarg_end
	cmpi.b	#' ',d1
	beq	getarg_end
	cmpi.b	#9,d1
	beq	getarg_end
	bra	getarg_L2

getarg_end:
	clr.b	(a1)
	move.l	(sp)+,d1
	rts

	.bss
	.even

fp1:	.ds.w	1
fp2:	.ds.w	1
rbuff:	.ds.b	read_buf_len
wbuff:	.ds.b	write_buf_len

	.data
	.even

finish_m:
	.dc.b	'Complete !',$0d,$0a,0
ERR_MES:
	.dc.b	'ERROR!!',$0d,$0a,0

	.bss
	.even

I_fname:
	.ds.b	1024
O_fname:
	.ds.b	1024

	.stack
	.even

	.ds.l	1000
usersp:
	.end
