(setq scroll-step 2)
;;(setq load-path (append '("b:/emacs/bytecomp2")
;;			'("b:/emacs/gnus") load-path '("a:/home/emacs/lisp")))

;;(setq inhibit-fep-control t)
;;(setq kept-new-versions 5)
;;(setq kept-old-versions 5)
(setq save-buffer-context t)
(setq auto-save-default nil)
(setq compile-command "make")
(setq c-auto-newline t)
(setq kinsoku-nobashi-limit 2)
(put 'eval-expression 'disabled nil)
(if (eq window-system 'sx)
    nil
  (setq auto-save-and-recover-context t))

;;(autoload 'gnus "gnus" "Read network news." t)
(autoload 'set-x68-crtmod-18 "~/usercom" nil t)
(autoload 'set-x68-crtmod-16 "~/usercom" nil t)
(autoload 'set-x68-crtmod-1 "~/usercom" nil t)
(autoload 'keisen-mode "keisen-mule" "keisen-mode." t)
(autoload 'kill-word-wordstarlike "~/usercom" nil t)
(autoload 'insert-name-and-current-time-as-comment "~/usercom" nil t)
(autoload 'delete-ish "~/usercom" nil t)
(autoload 'delete-esc-sequence "~/usercom" nil t)
(autoload 'cr-to-lf "~/usercom" nil t)
(autoload 'attribute-inverse-region "~/usercom" nil t)
(autoload 'attribute-bold-region "~/usercom" nil t)
(autoload 'attribute-underline-region "~/usercom" nil t)
(autoload 'run-lisp "sxprocess" nil t)

(define-key global-map "\M-C" 'compile)
(define-key global-map "\C-x\C-b" 'buffer-menu)
(global-set-key "\C-t" 'kill-word-wordstarlike)

;;(autoload 'sunday-set-muterm-macro "sunday.el" "set muterm macro for sunday net" t)
(autoload 'sshell "sshell" "inferior inferior synchronous shell" t)
;;(autoload 'hide-ifdef-mode "hideif" "toggle hide-ifdef mode" t)

(defun auto-fill-indented-text-mode ()
  (interactive)
  (indented-text-mode)
  (auto-fill-mode 1))

(setq auto-mode-alist (cons '("\\.doc$" . auto-fill-indented-text-mode ) auto-mode-alist))
(setq auto-mode-alist (cons '("\\.DOC$" . auto-fill-indented-text-mode ) auto-mode-alist))
(setq auto-mode-alist (cons '("\\.\\$\\$\\$$" . auto-fill-indented-text-mode ) auto-mode-alist))
(setq text-mode-hook '(lambda () (set-fill-column 62)))

;;(load "~/aucinit")
(global-set-key "\C-C\C-I" 'insert-name-and-current-time-as-comment)
(global-set-key "\C-Ci" 'attribute-inverse-region)
(global-set-key "\C-Cb" 'attribute-bold-region)
(global-set-key "\C-Cu" 'attribute-underline-region)
(global-set-key "\C-C\C-I" 'insert-name-and-current-time-as-comment)
;;(global-set-key "\C-ci" 'insert-email-address)
;;


;;
;; following is term-init-file
;;

(setq inhibit-startup-message t)
(setq term-file-prefix nil)
(setq inhibit-default-init t)

;;; X68000 usually encourage using ^H as the rubout character
;;; base on code bobcat.el
;;; modifyed 93-01-13 T.Ishikura

(let ((the-table (make-string 128 0)))
  (let ((i 0))
    (while (< i 128)
      (aset the-table i i)
      (setq i (1+ i))))
  ;; Change ^H -> DEL, ^\ -> ^H
  (aset the-table ?\^\\ ?\^h)
  (aset the-table ?\^h ?\177)
  (setq keyboard-translate-table the-table))

;;;; Make X68-raw-map to handle X68000 terminal function keys...
;;
;;(defvar X68-raw-map (make-sparse-keymap) "*Keymap for ESC-[ encoded keyboard")
;;
;;(define-key X68-raw-map "A" 'beginning-of-buffer) ; F1
;;(define-key X68-raw-map "B" 'end-of-buffer)	  ; F2
;;(define-key X68-raw-map "C" 'replace-string)	  ; F3
;;(define-key X68-raw-map "D" 'isearch-forward)	  ; F4
;;(define-key X68-raw-map "E" "?????")		  ; F5
;;(define-key X68-raw-map "F" 'set-mark-command)    ; F6
;;(define-key X68-raw-map "G" 'kill-region)	  ; F7
;;(define-key X68-raw-map "H" 'copy-region-as-kill) ; F8
;;(define-key X68-raw-map "I" 'yank)		  ; F9
;;(define-key X68-raw-map "J" 'suspend-emacs)	  ; F10
;;(define-key X68-raw-map "a" 'shrink-window)	  ; F11
;;(define-key X68-raw-map "b" 'enlarge-window)	  ; F12
;;(define-key X68-raw-map "c" "?????")		  ; F13
;;(define-key X68-raw-map "d" 'isearch-backward)	  ; F14
;;(define-key X68-raw-map "e" "?????")		  ; F15
;;(define-key X68-raw-map "f" "?????")		  ; F16
;;(define-key X68-raw-map "g" "?????")		  ; F17
;;(define-key X68-raw-map "h" "?????")		  ; F18
;;(define-key X68-raw-map "i" "?????")		  ; F19
;;(define-key X68-raw-map "j" "?????")		  ; F20
;;(define-key X68-raw-map "K" 'scroll-up)	          ; ROLLUP
;;(define-key X68-raw-map "L" 'scroll-down)         ; ROLLDOWN
;;(define-key X68-raw-map "M" "?????")		  ; INS
;;(define-key X68-raw-map "N" 'delete-char)	  ; DEL
;;(define-key X68-raw-map "O" 'previous-line)	  ; UP
;;(define-key X68-raw-map "P" 'backward-char)	  ; LEFT
;;(define-key X68-raw-map "Q" 'forward-char)	  ; RIGHT
;;(define-key X68-raw-map "R" 'next-line)	  	  ; DOWN
;;(define-key X68-raw-map "T" 'help-for-help)	  ; HELP
;;(define-key X68-raw-map "U" 'other-window)	  ; HOME
;;(define-key X68-raw-map "V" 'next-error)	  ; UNDO
;;
;;;; sxwindow event
;;
;;(define-key X68-raw-map "0" 'kill-emacs)		; ENDTSK, CLOSEALL
;;(define-key X68-raw-map "1" 'sx-save-buffers-kill-emacs); SAVE
;;(define-key X68-raw-map "2" 'sx-drag)			; DRAG
;;(define-key X68-raw-map "3" 'save-buffers-kill-emacs)	; CLOSE BUTTOM
;;(define-key X68-raw-map "4" 'sx-mouse-left-down)	; MOUSE LEFT DOWN
;;(define-key X68-raw-map "5" 'sx-mouse-right-down)	; MOUSE RIGHT DOWM
;;
;;(define-key global-map "\C-^" X68-raw-map)	  ; Install X68-raw-map
;;